module PlanetExpressExpress
  # A very simple implementation of an object pool for
  # shipments.
  #
  # Using it you can reduce the memory allocations
  class ShipmentPool
    def initialize(size: 100)
      @entries = []
      size.times do
        @entries.push(Shipment.new())
      end
    end

    def get()
      entry = @entries.pop
      return entry if entry
      Shipment.new
    end

    def put_back(shipment_entries)
      @entries.push(*shipment_entries)
    end
  end
end
